/*
4 modes:
 flash: alle lampen haben die gleiche farbe (konstant)
 strobe: lebendige farben d.h. alle lampen faden zwischen ähnlichen zufallsfarben
 fade: alle lampen faden nach programm, z.b. regenbogen, sunrise-sunset, alle gleichzeitig usw
 smooth: programmiermodus, farben können beliebig gewählt werden und zwar:
 -heller, dunkler tasten ändern Hue
 -rot und grün ändern helligkeit
 -blau und weiss ändern sättigung
 -restliche tasten entsprechen presets
 -man wählt ein preset, dieses wird geladen
 -langer druck auf preset speichert neue werte-> zusätzlicher buffer erforderlich um aktuell programmierte zwischenzuspeichern und nach langem tastendruck zu speichern
 
 zusätzlich nötig: speichern des modes und aktuellem preset falls länger als 10sek keine taste gedrückt wird, dann laden des letzten modes bei reboot
 
 
 */


void processcommand() //die commands sind fix vond er fernbedienung vorgegeben, commands werden im interrupt capture generiert (=interrupt basiert)
{

  //toggleLED();
  static byte progprop = 0;  //selects the property to be changed in programming mode 0 = hue, 1=saturation, 2=value, 3 = select lamp


  if(command == 61965) //OFF
  {
    switch(mode)
    { 


    case 3: //programming mode, switch current lamp off
      //first, copy current color to global hsv buffer as a backup (in case on is pressed afterwards) this can also be used as a copy past 
      //unction (this being the copy)
      
   
      globalHSV[0] = hsvbuffer[0][currentlamp];
      globalHSV[1] = hsvbuffer[1][currentlamp];
      globalHSV[2] = hsvbuffer[2][currentlamp];
      
    

     // hsvbuffer[0][currentlamp]= 0; //h
     // hsvbuffer[1][currentlamp]= 0; //s
      hsvbuffer[2][currentlamp]= 0; //v

     copytosecondaryHSV(); //buffer needs to be backed up after every color manipulation, in case user wants to save it to a key
        
   
      break;

    default: //if not in programming mode, switch off all lamps, save current mode and necessary buffers
    //missing: function to switch off all lamps
      SaveCurrentModeToEeprom();
      mode = 0; //switch to mode 0, all lamps same color
       globalHSV[2] = 0;
      break;

    }

  }
  if(command == 61455) { //"ON"

    switch(mode)
    { 


    case 3: //programming mode, set current lamp to global HSV (which may have been saved by OFF key)
      // this can also be used as a copy paste function (this being the paste)

      hsvbuffer[0][currentlamp]=  globalHSV[0]; //h
      hsvbuffer[1][currentlamp]=  globalHSV[1]; //s
      hsvbuffer[2][currentlamp]=  globalHSV[2]; //v
      
      hsv_to_rgb ( hsvbuffer[0][currentlamp],  hsvbuffer[1][currentlamp],  hsvbuffer[2][currentlamp], currentlamp);     //calc rgb values here for printout 

      //print out current lamp color to Serial (HSV and RGB);
      Serial.println("Current lamp color: ");
      Serial.print("H: "); Serial.println( hsvbuffer[0][currentlamp],DEC);
      Serial.print("S: "); Serial.println( hsvbuffer[1][currentlamp],DEC);
      Serial.print("V: "); Serial.println( hsvbuffer[2][currentlamp],DEC);
      Serial.print("R: ");  Serial.println( colorbuffer[0][currentlamp][1] ,DEC);
      Serial.print("G: ");  Serial.println( colorbuffer[1][currentlamp][1] ,DEC);
      Serial.print("B: "); Serial.println( colorbuffer[2][currentlamp][1] ,DEC);



      copytosecondaryHSV(); //buffer needs to be backed up after every color manipulation, in case we want to save it to a key
      break;

    default: //if not in programming mode
      RestoreCurrentModeFromEeprom();
      break;

    }
  }


  if(command == 60435) { //ROT


    switch(mode)
    { 
    case 0://change color of all lamps
      globalHSV[0] = 0; //hue = red
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness
      break;

    case 1: //similar color mode
      globalHSV[0] = 0; //hue = red
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, increase value
      progprop = 0; //select to change hue with increase/decrease buttons
      //now display that hue change was selected by tuning hue up and down fast for half a second
      showselection(progprop);
      break;

    }





  }


  if(command == 60945) { //GRUEN")


    switch(mode)
    { 
    case 0://change color of all lamps
      globalHSV[0] = 85; //hue = green
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness
      break;

    case 1: //similar color mode
      globalHSV[0] = 85; //hue = green
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, decrease value
      progprop = 1; //select to change saturation with increase/decrease buttons
      //now display that saturation change was selected by tuning saturation up and down fast for half a second
      showselection(progprop);
      break;

    }


  }


  if(command == 59925) { //BLAU")

    switch(mode)
    { 
    case 0://change color of all lamps
      globalHSV[0] = 170; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness
      break;

    case 1: //similar color mode
      globalHSV[0] = 170; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, increase value
      progprop = 2; //select to change value with increase/decrease buttons
      //now display that hue change was selected by tuning value up and down fast for half a second
      showselection(progprop);       
      break;

    }

  }


  if(command == 59415) { //WEISS")


    switch(mode)
    { 
    case 0://change color of all lamps
      globalHSV[0] = 39; //hue = yellow
      globalHSV[1] = 90; //s= low, whitish color
      globalHSV[2] = 255; //v=full brightness
      break;

    case 1: //similar color mode
      randomizecolorchange = 1;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, decrease saturation

      progprop = 3; //select to "select lamp mode" with increase/decrease buttons
      //now display that "select lamp mode" was selected 
      showselection(progprop);
      break;

    }
  }

  if(command == 58395) { //"ORANGE")
    presetkeyno = 0;

    switch(mode)
    { 
    case 0://change color of all lamps
      globalHSV[0] = 8; //hue = orange
      globalHSV[1] = 255; //s= low, whitish color
      globalHSV[2] = 255; //v=full brightness
      break;

    case 1: //similar color mode
      globalHSV[0] = 8; //hue = orange
      globalHSV[1] = 255; //s= low, whitish color
      globalHSV[2] = 255; //v=full brightness
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(0); //store hsv buffers in eeprom at corresponding position
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(0);
      break;

    }

  }

  if(command == 58905) { //"HELLGRUEN")
    presetkeyno = 1;
    switch(mode)
    { 
    case 0://change color of all lamps

      globalHSV[0] = 50; //hue = green
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness

      break;

    case 1: //similar color mode

      globalHSV[0] = 50; //hue = green
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(1); //store hsv buffers in eeprom at corresponding position
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(1);
      break;

    }


  }


  if(command == 57885) { //"BLAU (heller)")

    presetkeyno = 2;

    switch(mode)
    { 
    case 0://change color of all lamps

      globalHSV[0] = 145; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness


      break;

    case 1: //similar color mode

      globalHSV[0] = 145; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness
      randomizecolorchange = 0;

      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(2); //store hsv buffers in eeprom at corresponding position
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(2);
      break;

    }

  }



  if(command == 54315) { //"ORANGE-GELB")
    presetkeyno = 3;
    switch(mode)
    { 
    case 0://change color of all lamps

      globalHSV[0] = 20; //hue = orange
      globalHSV[1] = 255; //s= low, whitish color
      globalHSV[2] = 255; //v=full brightness


      break;

    case 1: //similar color mode

      globalHSV[0] = 20; //hue = orange
      globalHSV[1] = 255; //s= low, whitish color
      globalHSV[2] = 255; //v=full brightness
      randomizecolorchange = 0;

      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(3); //store hsv buffers in eeprom at corresponding position
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(3);
      break;

    }
  }






  if(command == 54825) { //"Cyan")
    presetkeyno = 4;

    switch(mode)
    { 
    case 0://change color of all lamps

      globalHSV[0] = 135; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness

      break;

    case 1: //similar color mode

      globalHSV[0] = 135; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(4); //store hsv buffers in eeprom at corresponding position
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(4);
      break;

    }
  }


  if(command == 53805) { //"Violet")

    presetkeyno = 5;
    switch(mode)
    { 
    case 0://change color of all lamps

      globalHSV[0] = 190; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 245; //v

      break;

    case 1: //similar color mode

      globalHSV[0] = 190; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 245; //v
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(5); //store hsv buffers in eeprom at corresponding position
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(5);
      break;

    }
  }




  if(command == 52275) { //"Dunkelgelb")

    presetkeyno = 6;


    switch(mode)
    { 
    case 0://change color of all lamps

      globalHSV[0] = 26; //hue = orange
      globalHSV[1] = 255; //s= low, whitish color
      globalHSV[2] = 255; //v=full brightness

      break;

    case 1: //similar color mode

      globalHSV[0] = 26; //hue = orange
      globalHSV[1] = 255; //s= low, whitish color
      globalHSV[2] = 255; //v=full brightness
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(6); //store hsv buffers in eeprom at corresponding position
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(6);
      break;

    }
  }


  if(command == 52785) { //"Cyan-blau")    
    presetkeyno = 7;
    switch(mode)
    { 
    case 0://change color of all lamps

      globalHSV[0] = 139; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness

      break;

    case 1: //similar color mode
      globalHSV[0] = 139; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v=full brightness
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(7); //store hsv buffers in eeprom at corresponding position
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(7);
      break;

    }
  }

  if(command == 51765) { //"Lila-Violet")
    presetkeyno = 8;
    switch(mode)
    { 
    case 0://change color of all lamps

      globalHSV[0] = 200; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v

      break;

    case 1: //similar color mode
      globalHSV[0] = 200; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(8); //store hsv buffers in eeprom at corresponding position
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(8);
      break;

    }
  }



  if(command == 56355) { //"Gelb")
    presetkeyno = 9;

    switch(mode)
    { 
    case 0://change color of all lamps


      globalHSV[0] = 35; //hue = gelb
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v

      break;

    case 1: //similar color mode

      globalHSV[0] = 35; //hue = gelb
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 255; //v
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(9); //store hsv buffers in eeprom at corresponding position
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(9);
      break;

    }
  }


  if(command == 56865) { //"Hellblau")

    presetkeyno = 10;

    switch(mode)
    { 
    case 0://change color of all lamps
      globalHSV[0] = 150; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 245; //v

      break;

    case 1: //similar color mode
      globalHSV[0] = 150; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 245; //v
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(10); //store hsv buffers in eeprom at corresponding position
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(10);
      break;

    }
  }


  if(command == 55845) { //"Lila")
    presetkeyno = 11;

    switch(mode)
    { 
    case 0://change color of all lamps
      globalHSV[0] = 200; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 245; //v

      break;

    case 1: //similar color mode
      globalHSV[0] = 200; //hue = blue
      globalHSV[1] = 255; //s= full
      globalHSV[2] = 245; //v
      randomizecolorchange = 0;
      break;

    case 2: //rainbow 
      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, read colorset, if longpressed: save colorset

      if(longtimepressed)
      {
        longtimepressed = 0;
        //save previously set colors to eeprom:
        copyfromsecondaryHSV(); //read previously manipulated color values from secondary buffer
        writehsvbufferstoeeprom(11); //store hsv buffers in eeprom at corresponding position
        blinkcurrentlamp();
      }
      else //read hsv buffer from eeprom
      readhsvbuffersfromeeprom(11);
      break;

    }


  }


  if(command == 62475) { //"increase"  1110100000010111 , 1111010000001011
    Serial.println("increase");

    switch(mode)
    { //change color of all lamps
    case 0:
      globalHSV[0]++;
      globalHSV[1] = 255;
      globalHSV[2] = 255;
      break;

    case 1: //similar color mode, increase color spread
      colordeviation++; 
      break;

    case 2: //rainbow 
      initrainbow(++rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, increase hue
      switch(progprop)
      { 
      case 0://change hue
        hsvbuffer[0][currentlamp]++;

        break;

      case 1: //change saturation
        hsvbuffer[1][currentlamp]++;
        break;

      case 2: //change value 
        hsvbuffer[2][currentlamp]++;
        break;

      case 3: //select lamp
        currentlamp++; 
        if(currentlamp > 5) currentlamp = 0;
        blinkcurrentlamp();
        break;
      }

      copytosecondaryHSV(); //buffer needs to be backed up after every color manipulation, in case use wants to save it to a key
      break;

    }

  }

  if(command == 62985) { //"decrease"
    Serial.println("decrease");
    switch(mode)
    { 
    case 0://change color of all lamps
      globalHSV[0]--;
      globalHSV[1] = 255;
      globalHSV[2] = 255;
      break;

    case 1: //similar color mode, decrease color spread
      colordeviation --; 
      if(colordeviation < 0) colordeviation = 0; 
      break;

    case 2: //rainbow
      if(rainbowstretch > 1)
        rainbowstretch--;

      initrainbow(rainbowstretch); //init rainbow pattern
      break;

    case 3: //programming mode, decrease hue, saturation or value, or select lamp, depending on progprop

      switch(progprop)
      { 
      case 0://change hue
        hsvbuffer[0][currentlamp]--;

        break;

      case 1: //change saturation
        hsvbuffer[1][currentlamp]--;
        break;

      case 2: //change value 
        hsvbuffer[2][currentlamp]--;
        break;

      case 3: //select lamp
        currentlamp--; //will switch to 255 on negative overflow
        if(currentlamp > 5) currentlamp = 5;
        blinkcurrentlamp();
        break;
      }

      copytosecondaryHSV(); //buffer needs to be backed up after every color manipulation, in case use wants to save it to a key
      break;

    }

  }



  if(command == 57375) { //"FLASH" alle die gleiche konstantfarbe
    mode=0;
    modechanged = 1;
    //    for(int i = 0; i<6;i++)
    //    {
    //      setcolorbuffertocurrent(i); //copy current color to endbuffer
    //      phase[i]=5; 
    //    }
  }

  if(command == 53295) { //"STROBE" lebendige farben
    mode=1;
    modechanged = 1;
    //    for(int i = 0; i<6;i++)
    //    {
    //      setcolorbuffertocurrent(i); //copy current color to endbuffer
    //      phase[i]=5; 
    //    }
  }


  if(command == 51255) { //FADE", farbwechsel, nach programm (rainbow, sunrise sunset, etc.

    mode=2; //fade
    modechanged = 1;
    rainbowstretch = 6;
    initrainbow(rainbowstretch); //init rainbow pattern
  }



  if(command == 55335) { //SMOOTH programmiermodus & presets
    mode=3; //program mode
    modechanged = 1;
  }


}




void showselection(byte selection) //blinks/fades currentlamp in programming mode to show selecte lamp and or selected variable to change (hue, saturation, value)
{
  copytosecondaryHSV(); //buffer needs to be backed up, we are messing with the primary buffer
  switch(selection)
  {
  case 0: //hue: tune hue of current lamp up and down
   // hsvbuffer[1][currentlamp]=220;
    for(int i = 0; i < 255; i++) 
    {
      hsvbuffer[0][currentlamp]+=1;
      setlamptoHSV(hsvbuffer[0][currentlamp], hsvbuffer[1][currentlamp], hsvbuffer[2][currentlamp], currentlamp); //set color to primary HSV buffer
      updatelamp(currentlamp);
      delay(5);
    }
    break;


  case 1: //saturation: tune saturation up and down
    for(int i = 0; i < 100; i++) 
    {
      if(hsvbuffer[1][currentlamp]>0) hsvbuffer[1][currentlamp]-=2;
      else break;
      setlamptoHSV(hsvbuffer[0][currentlamp], hsvbuffer[1][currentlamp], hsvbuffer[2][currentlamp], currentlamp); //set color to primary HSV buffer
      updatelamp(currentlamp);
      delay(8);
    }
    for(int i = 0; i < 100; i++) 
    {
      if(hsvbuffer[1][currentlamp]<255) hsvbuffer[1][currentlamp]+=2;
      else break;
      setlamptoHSV(hsvbuffer[0][currentlamp], hsvbuffer[1][currentlamp], hsvbuffer[2][currentlamp], currentlamp); //set color to primary HSV buffer
      updatelamp(currentlamp);
      delay(8);
    }
    break;


  case 2: //value: tune brightness down and up
    for(int i = 0; i < 100; i++) 
    {
      if(hsvbuffer[2][currentlamp]>0) hsvbuffer[2][currentlamp]-=2;
      else break;
      setlamptoHSV(hsvbuffer[0][currentlamp], hsvbuffer[1][currentlamp], hsvbuffer[2][currentlamp], currentlamp); //set color to primary HSV buffer
      updatelamp(currentlamp);
      delay(8);
    }
    for(int i = 0; i < 100; i++) 
    {
      if(hsvbuffer[2][currentlamp]<255) hsvbuffer[2][currentlamp]+=2;
      else break;

      setlamptoHSV(hsvbuffer[0][currentlamp], hsvbuffer[1][currentlamp], hsvbuffer[2][currentlamp], currentlamp); //set color to primary HSV buffer
      updatelamp(currentlamp);
      delay(8);
    }
    break;
  case 3: //lamp select: blink lamps, knightrider style
    byte lamp = currentlamp;
    for(int i = 0; i < 12; i++) 
    {
      lamp++;
      if(lamp >5) lamp = 0;
      color[0][lamp] = 255; //set white
      color[1][lamp] = 220;
      color[2][lamp] = 200;
      updatelamp(lamp);
      delay(80); 
      setlamptoHSV( secondaryhsvbuffer[0][lamp],  secondaryhsvbuffer[1][lamp],  secondaryhsvbuffer[2][lamp], lamp); //restore original color
      updatelamp(lamp);
    }


    break;

    //restore original color:
    setlamptoHSV( secondaryhsvbuffer[0][currentlamp],  secondaryhsvbuffer[1][currentlamp],  secondaryhsvbuffer[2][currentlamp], currentlamp);
    updatelamp(currentlamp);
  }

}

void blinkcurrentlamp(void) //blinks to white and back to current color to show selection
{


  color[0][currentlamp] = 0; //set dark
  color[1][currentlamp] = 0;
  color[2][currentlamp] = 0;
  updatelamp(currentlamp);
  delay(50);
  color[0][currentlamp] = 255; //set white
  color[1][currentlamp] = 250;
  color[2][currentlamp] = 180;
  updatelamp(currentlamp);
  delay(50);
  color[0][currentlamp] = 0; //set dark
  color[1][currentlamp] = 0;
  color[2][currentlamp] = 0;
  updatelamp(currentlamp);
  delay(50);
  setlamptoHSV(hsvbuffer[0][currentlamp], hsvbuffer[1][currentlamp], hsvbuffer[2][currentlamp], currentlamp); //now go back to previous color
  updatelamp(currentlamp);

}































