//master für lichtorgel by Damian Schneider
//running on atmega 368

//to do:
//-fan on off für master (pin13, high = on)
//


#include <Wire.h>
#include <util/twi.h> 
#include <EEPROM.h>
#include <util/crc16.h> //crc16 calculation
#include <avr/pgmspace.h>

#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif

#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif

//#define TWIDEBUG 1 //if defined, successful twi commands are counted and output to serial

//#ifdef TWIDEBUG
long sendsuccessful = 0;
long sendfailed = 0;
//long TWI_FREQ = 50000;
long lasttime = 0;
//#else
#define TWI_FREQ 400000L //maybe best is 200000L
//#endif

#define CPU_FREQ 16000000L
#define RED 0
#define GREEN 1
#define BLUE 2

PROGMEM const uint16_t pwmtable_13[] = {
  0	,
  1	,
  1	,
  2	,
  2	,
  3	,
  4	,
  5	,
  6	,
  7	,
  8	,
  8	,
  9	,
  10	,
  11	,
  12	,
  13	,
  14	,
  15	,
  16	,
  17	,
  18	,
  19	,
  21	,
  22	,
  23	,
  24	,
  25	,
  27	,
  28	,
  29	,
  31	,
  32	,
  33	,
  35	,
  36	,
  38	,
  39	,
  41	,
  43	,
  44	,
  46	,
  48	,
  49	,
  51	,
  53	,
  55	,
  57	,
  59	,
  61	,
  63	,
  65	,
  67	,
  69	,
  71	,
  74	,
  76	,
  78	,
  81	,
  83	,
  86	,
  88	,
  91	,
  94	,
  97	,
  99	,
  102	,
  105	,
  108	,
  111	,
  115	,
  118	,
  121	,
  125	,
  128	,
  131	,
  135	,
  139	,
  143	,
  146	,
  150	,
  154	,
  158	,
  163	,
  167	,
  171	,
  176	,
  180	,
  185	,
  190	,
  195	,
  200	,
  205	,
  210	,
  215	,
  221	,
  226	,
  232	,
  238	,
  244	,
  250	,
  256	,
  262	,
  269	,
  275	,
  282	,
  289	,
  296	,
  303	,
  311	,
  318	,
  326	,
  334	,
  342	,
  350	,
  359	,
  367	,
  376	,
  385	,
  394	,
  404	,
  413	,
  423	,
  433	,
  443	,
  454	,
  464	,
  475	,
  486	,
  498	,
  509	,
  521	,
  534	,
  546	,
  559	,
  572	,
  585	,
  599	,
  612	,
  627	,
  641	,
  656	,
  671	,
  687	,
  702	,
  719	,
  735	,
  752	,
  769	,
  787	,
  805	,
  823	,
  842	,
  861	,
  881	,
  901	,
  922	,
  943	,
  964	,
  986	,
  1008	,
  1031	,
  1055	,
  1079	,
  1103	,
  1128	,
  1153	,
  1179	,
  1206	,
  1233	,
  1261	,
  1290	,
  1319	,
  1348	,
  1379	,
  1410	,
  1442	,
  1474	,
  1507	,
  1541	,
  1576	,
  1611	,
  1647	,
  1684	,
  1722	,
  1760	,
  1800	,
  1840	,
  1881	,
  1924	,
  1967	,
  2011	,
  2055	,
  2101	,
  2148	,
  2196	,
  2245	,
  2295	,
  2347	,
  2399	,
  2452	,
  2507	,
  2563	,
  2620	,
  2678	,
  2738	,
  2799	,
  2861	,
  2925	,
  2990	,
  3056	,
  3124	,
  3194	,
  3265	,
  3337	,
  3411	,
  3487	,
  3565	,
  3644	,
  3725	,
  3807	,
  3892	,
  3978	,
  4066	,
  4156	,
  4249	,
  4343	,
  4439	,
  4537	,
  4638	,
  4741	,
  4846	,
  4953	,
  5063	,
  5175	,
  5289	,
  5406	,
  5526	,
  5648	,
  5773	,
  5901	,
  6031	,
  6165	,
  6301	,
  6440	,
  6583	,
  6728	,
  6877	,
  7029	,
  7184	,
  7343	,
  7505	,
  7671	,
  7841	,
  8014	,
  8191	

};  

//softpwm
uint8_t colorcomparevalue[3]; //value that is written to compare match unit
uint8_t colorcomparevalue_buffer[3];
uint16_t color16bitvalue[3]; //dutycycle in 16bit value
uint8_t coloroverflowvalue[3]; //number of timer2 overflows necessary to reach the dutycycle
uint8_t coloroverflowvalue_buffer[3];


uint8_t timer2counter = 0;
uint8_t pwmbufferready = 0; //is set to 1 if new pwm buffer is ready, for synched color change (no jittering during update)


//stuff
long loopcounter = 0;
byte twireset = 0;
byte debug = 0;

//diese farben werden an die leds gegeben
byte color[3][6]; //color[RGB][lamp_no], color commands that are sent out to lamps
//farbbuffer für blend oder andere funktionen
byte colorbuffer[3][6][2]; //colorbuffer[RGB][lamp_no][buffer_no], buffer for fading
byte hsvbuffer[3][6]; //buffer for functions using HSV mode
byte secondaryhsvbuffer[3][6]; //backup buffer, all manipulations are double buffered here, necessary for the long-pressed routine 
//because if a new key is pressed, those values are loaded, if it turns out to be a long pressed, the previous set values are availab

//in this secondary buffer
byte globalHSV[3]; //global HSV mode color that is valid for all lamps (used in fade all, and as a master color in vivid color mode)
byte globalHSV2[3]; //secondary global HSV buffer used in chained color change of vivid color mode
byte usebuffer[6] = {0,0,0,0,0,0}; //lamp uses global hsv buffer 1 or 2
byte changed = 0; //used as binary buffer to check if lamp needs to adapt to new buffer
byte TWIwatchdog = 0; //watchodog counter for TWI

//

byte mode = 1; //0=steady color, 1=rainbow, 2 = fade, 3 = similar colors
byte rainbowstretch = 5;
byte colordeviation = 40; 
uint8_t commandindex;  
byte longtimepressed = 0; //is set to 1 if button is pressed a long time (i.e. >2.5s)
byte modechanged = 0; //set to 1 if mode changed, used to detect if mode needs saving to eeprom

byte currentlamp = 0; //currently selected lamp in programming mode
uint8_t command_repeat = 0; //is set to 1 if repeat command is received
uint8_t command_received = 0; //is set to 1 if command is received successfully
uint16_t command = 0;  //contains received IR command
long commandrepeattiming = 0;
long pressedlongtiming = 0;
byte presetkeyno = 0; //key no that was pressed, 0...11  this info is backed up in eeprom
byte randomizecolorchange = 0;

//uint8_t brightness = 0;
//uint8_t phase = 0;
//uint8_t fade = 0;
//uint8_t smooth = 0;
//uint8_t flash = 0;
uint32_t time = 0; //counts timer1 ticks for IR remote

unsigned long timestamp; //timesteamp for colorchange
long interval = 10000; //time in ms to change the color, is randomized once started



byte phase[6] = {
  5,5,5,5,5,5}; //phase for fading

void setup()
{
  Serial.begin(115200);
  randomSeed(analogRead(0));

  pinMode(6, OUTPUT);
  pinMode(7, OUTPUT);
  digitalWrite(9, LOW); //
  digitalWrite(10, LOW); //
  digitalWrite(11, LOW); //
  digitalWrite(13, LOW); //
  pinMode(9, OUTPUT); //pwm, rot
  pinMode(10, OUTPUT); //pwm grün
  pinMode(11, OUTPUT);//pwm blau
  pinMode(13, OUTPUT); //fan
  digitalWrite(6, LOW); //=GND für IR
  digitalWrite(7,HIGH);  //= VCC für IR
  pinMode(8,INPUT);   //input capture  (arduino pin8) als eingang 

  init_twi();



  TCCR1A = (1 << COM1A1) | (0 << COM1A0) | (1 << COM1B1) | (0 << COM1A0)  | (0 << WGM11) | (1 << WGM10);  //fast pwm, 8bit, phase correct output, both ports as outputs (pint 9&10)
  TCCR1B = (0 << WGM13) | (0 << WGM12) | (0 << CS12) | (1 << CS11) | (0 << CS10);  //prescaler:8 (244Hz pwm), capture falling edge (default)

  TCCR2A = (0 << COM2A1) | (0 << COM2A0) | (0 << COM2B1) | (0 << COM2A0)  | (1 << WGM21) | (1 << WGM20);  //fast pwm, 8bit, phase correct output, no output
  TCCR2B = (0 << WGM22) | (0 << CS22) | (1 << CS21) | (0 << CS20);  //prescaler:8

  TIMSK2 = (1 << TOIE2); //handles PWM settings
  TIMSK1 = (1 << ICIE1) | (1 << TOIE1); //enable timer1 input capture and overflow interrupts


 RestoreCurrentModeFromEeprom(); //get last active mode

  Serial.println("setup done");


}

byte x = 0;

void loop()
{
  //Serial.println("loop start");

  switch(mode)
  {
  case 0://set all to same color

    //to do: make them fade slowly to new color plus make it slight color deviations
    for(int i = 0; i < 6; i++) //set all colors of all lamps to global HSV
    {
      hsv_to_rgb(globalHSV[0], globalHSV[1], globalHSV[2], i); //sets endbuffer to global HSV
      setcurrenttocolorbuffer(i); //set current color to endbuffer
    }

    break;

  case 1://vivid colors

    delay(20);
    if(randomizecolorchange)
    {

      globalHSV[1] = 255; //set reference to full saturation
      globalHSV[2] = 255; //set reference to full brightness
      globalHSV2[1] = 255; //set reference2 to full saturation
      globalHSV2[2] = 255; //set reference2 to full brightness
      if(millis()-timestamp > interval) //after x seconds
      {
        
        changed = 0; //new color, set all to "not changed yet"
        byte chosenone = random(0,5); //select the lamp that initiates change
        interval = random(20000, 150000); //randomize color change interval between 20 and 150 seconds
        timestamp = millis(); //save new timestamp
        
         //note: the "chosenone" change code is not working like it should
        //uncomment the fallowing lines if you want to test it...
         globalHSV[0] = random(255); //get a random color to change to (comment this line if you use chosenone code)
         
        /*
        if(usebuffer[chosenone]) //which buffer is the active one?
        {
          globalHSV[0] = random(255); //get a random color to change to
          usebuffer[chosenone] = 0; //lamps start now useing primary buffer
        }
        else
        {
          globalHSV2[0] = random(255); //get a random color to change to
          usebuffer[chosenone] = 1; //lamps start now useing secondary buffer
        }
        changed |= 1<<chosenone;
        */
        
        
      }
    }

    similarcolors();

    break;


  case 2: //fade modes
  
     //delay(5); //shart delay to slow down the fading


    rainbow();

 

    break;

  case 3://programming and preset mode: set lamps to current HSV buffer

    for(int i = 0; i < 6; i++) //set all colors of all lamps to primary HSV buffer
    {
      setlamptoHSV(hsvbuffer[0][i], hsvbuffer[1][i], hsvbuffer[2][i], i);
    }


    break;

  }



  if(command_received)
  { 
    // Serial.println("new command received :");
    //  Serial.println(command,DEC);
    //hier timing für long pressed, dan unten abfragen
    pressedlongtiming = millis();
    toggleLED();
    processcommand();
    command_received = 0;

  }
  if(command_repeat>5)
  {
    // Serial.println("repeating command");
    if(millis() - pressedlongtiming > 2000) 
    {
      pressedlongtiming = millis(); //reset time, repeat only after another long time
      longtimepressed = 1; //this gets proecessed in processcommand
    }
    toggleLED();
    processcommand();
    if(longtimepressed)
    {
      processcommand();
      processcommand();
    }
    command_repeat--;
  }
  if((millis()-commandrepeattiming) > 300) //if no repeat for 300ms
  {
    command_repeat = 0; //reset repeat variable
    if((millis()-commandrepeattiming) > 10000 && modechanged) //if no command received for 10seconds, save current mode to eeprom
    {
      SaveCurrentModeToEeprom(); 
      Serial.println("mode saved to eeprom");
      modechanged = 0;
    }
  }
  //Serial.println("updating lamps");
  updatelamp(0); 
  updatelamp(1);  
  updatelamp(2);  
  updatelamp(3);
  updatelamp(4);  
  updatelamp(5);

  if( color[RED][0] +  color[GREEN][0] +  color[BLUE][0] > 120)
  {
    digitalWrite(13, HIGH); //fan on
  }
  else  digitalWrite(13, LOW); //fan off
  //Serial.println("loop end");

  //#ifdef TWIDEBUG
  //
  //  if(sendsuccessful > 10000)
  //  {
  //    Serial.print("TWI frequency: ");
  //    Serial.print(TWI_FREQ,DEC);
  //    Serial.print(", success rate: ");
  //    Serial.print(sendsuccessful, DEC);
  //    Serial.print(" failed: ");
  //    Serial.print(sendfailed, DEC);
  //    Serial.print(" TWI resets: ");
  //    Serial.print(twireset,DEC);
  //    Serial.print(" Time: ");
  //    Serial.println(millis() - lasttime,DEC);
  //    twireset = 0;
  //    sendsuccessful = 0;
  //    sendfailed = 1;
  //    //TWI_FREQ += 50000;
  //    //if(TWI_FREQ > 1000000) TWI_FREQ = 50000;
  //    lasttime = millis();
  //  }
  //#endif


}















